<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_65) on Fri Aug 22 15:06:28 CEST 2014 -->
<title>Base64</title>
<meta name="date" content="2014-08-22">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="Base64";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Base64.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li><a href="../../../org/java_websocket/util/Base64.InputStream.html" title="class in org.java_websocket.util"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/util/Base64.html" target="_top">Frames</a></li>
<li><a href="Base64.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket.util</div>
<h2 title="Class Base64" class="title">Class Base64</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>org.java_websocket.util.Base64</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="strong">Base64</span>
extends java.lang.Object</pre>
<div class="block"><p>Encodes and decodes to and from Base64 notation.</p>
 <p>Homepage: <a href="http://iharder.net/base64">http://iharder.net/base64</a>.</p>
 
 <p>Example:</p>
 
 <code>String encoded = Base64.encode( myByteArray );</code>
 <br />
 <code>byte[] myByteArray = Base64.decode( encoded );</code>

 <p>The <tt>options</tt> parameter, which appears in a few places, is used to pass 
 several pieces of information to the encoder. In the "higher level" methods such as 
 encodeBytes( bytes, options ) the options parameter can be used to indicate such 
 things as first gzipping the bytes before encoding them, not inserting linefeeds,
 and encoding using the URL-safe and Ordered dialects.</p>

 <p>Note, according to <a href="http://www.faqs.org/rfcs/rfc3548.html">RFC3548</a>,
 Section 2.1, implementations should not add line feeds unless explicitly told
 to do so. I've got Base64 set to this behavior now, although earlier versions
 broke lines by default.</p>

 <p>The constants defined in Base64 can be OR-ed together to combine options, so you 
 might make a call like this:</p>

 <code>String encoded = Base64.encodeBytes( mybytes, Base64.GZIP | Base64.DO_BREAK_LINES );</code>
 <p>to compress the data before encoding it and then making the output have newline characters.</p>
 <p>Also...</p>
 <code>String encoded = Base64.encodeBytes( crazyString.getBytes() );</code>



 <p>
 Change Log:
 </p>
 <ul>
  <li>v2.3.7 - Fixed subtle bug when base 64 input stream contained the
   value 01111111, which is an invalid base 64 character but should not
   throw an ArrayIndexOutOfBoundsException either. Led to discovery of
   mishandling (or potential for better handling) of other bad input
   characters. You should now get an IOException if you try decoding
   something that has bad characters in it.</li>
  <li>v2.3.6 - Fixed bug when breaking lines and the final byte of the encoded
   string ended in the last column; the buffer was not properly shrunk and
   contained an extra (null) byte that made it into the string.</li>
  <li>v2.3.5 - Fixed bug in <a href="../../../org/java_websocket/util/Base64.html#encodeFromFile(java.lang.String)"><code>encodeFromFile(java.lang.String)</code></a> where estimated buffer size
   was wrong for files of size 31, 34, and 37 bytes.</li>
  <li>v2.3.4 - Fixed bug when working with gzipped streams whereby flushing
   the Base64.OutputStream closed the Base64 encoding (by padding with equals
   signs) too soon. Also added an option to suppress the automatic decoding
   of gzipped streams. Also added experimental support for specifying a
   class loader when using the
   <a href="../../../org/java_websocket/util/Base64.html#decodeToObject(java.lang.String,%20int,%20java.lang.ClassLoader)"><code>decodeToObject(java.lang.String, int, java.lang.ClassLoader)</code></a>
   method.</li>
  <li>v2.3.3 - Changed default char encoding to US-ASCII which reduces the internal Java
   footprint with its CharEncoders and so forth. Fixed some javadocs that were
   inconsistent. Removed imports and specified things like java.io.IOException
   explicitly inline.</li>
  <li>v2.3.2 - Reduced memory footprint! Finally refined the "guessing" of how big the
   final encoded data will be so that the code doesn't have to create two output
   arrays: an oversized initial one and then a final, exact-sized one. Big win
   when using the <a href="../../../org/java_websocket/util/Base64.html#encodeBytesToBytes(byte[])"><code>encodeBytesToBytes(byte[])</code></a> family of methods (and not
   using the gzip options which uses a different mechanism with streams and stuff).</li>
  <li>v2.3.1 - Added <a href="../../../org/java_websocket/util/Base64.html#encodeBytesToBytes(byte[],%20int,%20int,%20int)"><code>encodeBytesToBytes(byte[], int, int, int)</code></a> and some
   similar helper methods to be more efficient with memory by not returning a
   String but just a byte array.</li>
  <li>v2.3 - <strong>This is not a drop-in replacement!</strong> This is two years of comments
   and bug fixes queued up and finally executed. Thanks to everyone who sent
   me stuff, and I'm sorry I wasn't able to distribute your fixes to everyone else.
   Much bad coding was cleaned up including throwing exceptions where necessary 
   instead of returning null values or something similar. Here are some changes
   that may affect you:
   <ul>
    <li><em>Does not break lines, by default.</em> This is to keep in compliance with
      <a href="http://www.faqs.org/rfcs/rfc3548.html">RFC3548</a>.</li>
    <li><em>Throws exceptions instead of returning null values.</em> Because some operations
      (especially those that may permit the GZIP option) use IO streams, there
      is a possiblity of an java.io.IOException being thrown. After some discussion and
      thought, I've changed the behavior of the methods to throw java.io.IOExceptions
      rather than return null if ever there's an error. I think this is more
      appropriate, though it will require some changes to your code. Sorry,
      it should have been done this way to begin with.</li>
    <li><em>Removed all references to System.out, System.err, and the like.</em>
      Shame on me. All I can say is sorry they were ever there.</li>
    <li><em>Throws NullPointerExceptions and IllegalArgumentExceptions</em> as needed
      such as when passed arrays are null or offsets are invalid.</li>
    <li>Cleaned up as much javadoc as I could to avoid any javadoc warnings.
      This was especially annoying before for people who were thorough in their
      own projects and then had gobs of javadoc warnings on this file.</li>
   </ul>
  <li>v2.2.1 - Fixed bug using URL_SAFE and ORDERED encodings. Fixed bug
   when using very small files (~&lt; 40 bytes).</li>
  <li>v2.2 - Added some helper methods for encoding/decoding directly from
   one file to the next. Also added a main() method to support command line
   encoding/decoding from one file to the next. Also added these Base64 dialects:
   <ol>
   <li>The default is RFC3548 format.</li>
   <li>Calling Base64.setFormat(Base64.BASE64_FORMAT.URLSAFE_FORMAT) generates
   URL and file name friendly format as described in Section 4 of RFC3548.
   http://www.faqs.org/rfcs/rfc3548.html</li>
   <li>Calling Base64.setFormat(Base64.BASE64_FORMAT.ORDERED_FORMAT) generates
   URL and file name friendly format that preserves lexical ordering as described
   in http://www.faqs.org/qa/rfcc-1940.html</li>
   </ol>
   Special thanks to Jim Kellerman at <a href="http://www.powerset.com/">http://www.powerset.com/</a>
   for contributing the new Base64 dialects.
  </li>
 
  <li>v2.1 - Cleaned up javadoc comments and unused variables and methods. Added
   some convenience methods for reading and writing to and from files.</li>
  <li>v2.0.2 - Now specifies UTF-8 encoding in places where the code fails on systems
   with other encodings (like EBCDIC).</li>
  <li>v2.0.1 - Fixed an error when decoding a single byte, that is, when the
   encoded data was a single byte.</li>
  <li>v2.0 - I got rid of methods that used booleans to set options. 
   Now everything is more consolidated and cleaner. The code now detects
   when data that's being decoded is gzip-compressed and will decompress it
   automatically. Generally things are cleaner. You'll probably have to
   change some method calls that you were making to support the new
   options format (<tt>int</tt>s that you "OR" together).</li>
  <li>v1.5.1 - Fixed bug when decompressing and decoding to a             
   byte[] using <tt>decode( String s, boolean gzipCompressed )</tt>.      
   Added the ability to "suspend" encoding in the Output Stream so        
   you can turn on and off the encoding if you need to embed base64       
   data in an otherwise "normal" stream (like an XML file).</li>  
  <li>v1.5 - Output stream pases on flush() command but doesn't do anything itself.
      This helps when using GZIP streams.
      Added the ability to GZip-compress objects before encoding them.</li>
  <li>v1.4 - Added helper methods to read/write files.</li>
  <li>v1.3.6 - Fixed OutputStream.flush() so that 'position' is reset.</li>
  <li>v1.3.5 - Added flag to turn on and off line breaks. Fixed bug in input stream
      where last buffer being read, if not completely full, was not returned.</li>
  <li>v1.3.4 - Fixed when "improperly padded stream" error was thrown at the wrong time.</li>
  <li>v1.3.3 - Fixed I/O streams which were totally messed up.</li>
 </ul>

 <p>
 I am placing this code in the Public Domain. Do with it as you will.
 This software comes with no guarantees or warranties but with
 plenty of well-wishing instead!
 Please visit <a href="http://iharder.net/base64">http://iharder.net/base64</a>
 periodically to check for updates or to contribute improvements.
 </p></div>
<dl><dt><span class="strong">Version:</span></dt>
  <dd>2.3.7</dd>
<dt><span class="strong">Author:</span></dt>
  <dd>Robert Harder, rob@iharder.net</dd></dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Class and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.InputStream.html" title="class in org.java_websocket.util">Base64.InputStream</a></strong></code>
<div class="block">A <a href="../../../org/java_websocket/util/Base64.InputStream.html" title="class in org.java_websocket.util"><code>Base64.InputStream</code></a> will read data from another
 <tt>java.io.InputStream</tt>, given in the constructor,
 and encode/decode to/from Base64 notation on the fly.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util">Base64.OutputStream</a></strong></code>
<div class="block">A <a href="../../../org/java_websocket/util/Base64.OutputStream.html" title="class in org.java_websocket.util"><code>Base64.OutputStream</code></a> will write data to another
 <tt>java.io.OutputStream</tt>, given in the constructor,
 and encode/decode to/from Base64 notation on the fly.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#_ORDERED_ALPHABET">_ORDERED_ALPHABET</a></strong></code>
<div class="block">I don't get the point of this technique, but someone requested it,
 and it is described here:
 <a href="http://www.faqs.org/qa/rfcc-1940.html">http://www.faqs.org/qa/rfcc-1940.html</a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#_ORDERED_DECODABET">_ORDERED_DECODABET</a></strong></code>
<div class="block">Used in decoding the "ordered" dialect of Base64.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#_STANDARD_ALPHABET">_STANDARD_ALPHABET</a></strong></code>
<div class="block">The 64 valid Base64 values.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#_STANDARD_DECODABET">_STANDARD_DECODABET</a></strong></code>
<div class="block">Translates a Base64 value to either its 6-bit reconstruction value
 or a negative number indicating some other meaning.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#_URL_SAFE_ALPHABET">_URL_SAFE_ALPHABET</a></strong></code>
<div class="block">Used in the URL- and Filename-safe dialect described in Section 4 of RFC3548: 
 <a href="http://www.faqs.org/rfcs/rfc3548.html">http://www.faqs.org/rfcs/rfc3548.html</a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#_URL_SAFE_DECODABET">_URL_SAFE_DECODABET</a></strong></code>
<div class="block">Used in decoding URL- and Filename-safe dialects of Base64.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#DECODE">DECODE</a></strong></code>
<div class="block">Specify decoding in first bit.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES">DO_BREAK_LINES</a></strong></code>
<div class="block">Do break lines when encoding.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#DONT_GUNZIP">DONT_GUNZIP</a></strong></code>
<div class="block">Specify that gzipped data should <em>not</em> be automatically gunzipped.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#ENCODE">ENCODE</a></strong></code>
<div class="block">Specify encoding in first bit.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#EQUALS_SIGN">EQUALS_SIGN</a></strong></code>
<div class="block">The equals sign (=) as a byte.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#EQUALS_SIGN_ENC">EQUALS_SIGN_ENC</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#GZIP">GZIP</a></strong></code>
<div class="block">Specify that data should be gzip-compressed in second bit.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#MAX_LINE_LENGTH">MAX_LINE_LENGTH</a></strong></code>
<div class="block">Maximum line length (76) of Base64 output.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#NEW_LINE">NEW_LINE</a></strong></code>
<div class="block">The new line character (\n) as a byte.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#NO_OPTIONS">NO_OPTIONS</a></strong></code>
<div class="block">No options specified.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#ORDERED">ORDERED</a></strong></code>
<div class="block">Encode using the special "ordered" dialect of Base64 described here:
 <a href="http://www.faqs.org/qa/rfcc-1940.html">http://www.faqs.org/qa/rfcc-1940.html</a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#PREFERRED_ENCODING">PREFERRED_ENCODING</a></strong></code>
<div class="block">Preferred encoding.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#URL_SAFE">URL_SAFE</a></strong></code>
<div class="block">Encode using Base64-like encoding that is URL- and Filename-safe as described
 in Section 4 of RFC3548: 
 <a href="http://www.faqs.org/rfcs/rfc3548.html">http://www.faqs.org/rfcs/rfc3548.html</a>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#WHITE_SPACE_ENC">WHITE_SPACE_ENC</a></strong></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier</th>
<th class="colLast" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private </code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#Base64()">Base64</a></strong>()</code>
<div class="block">Defeats instantiation.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decode(byte[])">decode</a></strong>(byte[]&nbsp;source)</code>
<div class="block">Low-level access to decoding ASCII characters in
 the form of a byte array.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decode(byte[],%20int,%20int,%20int)">decode</a></strong>(byte[]&nbsp;source,
      int&nbsp;off,
      int&nbsp;len,
      int&nbsp;options)</code>
<div class="block">Low-level access to decoding ASCII characters in
 the form of a byte array.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decode(java.lang.String)">decode</a></strong>(java.lang.String&nbsp;s)</code>
<div class="block">Decodes data from Base64 notation, automatically
 detecting gzip-compressed data and decompressing it.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decode(java.lang.String,%20int)">decode</a></strong>(java.lang.String&nbsp;s,
      int&nbsp;options)</code>
<div class="block">Decodes data from Base64 notation, automatically
 detecting gzip-compressed data and decompressing it.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static int</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decode4to3(byte[],%20int,%20byte[],%20int,%20int)">decode4to3</a></strong>(byte[]&nbsp;source,
          int&nbsp;srcOffset,
          byte[]&nbsp;destination,
          int&nbsp;destOffset,
          int&nbsp;options)</code>
<div class="block">Decodes four bytes from array <var>source</var>
 and writes the resulting bytes (up to three of them)
 to <var>destination</var>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decodeFileToFile(java.lang.String,%20java.lang.String)">decodeFileToFile</a></strong>(java.lang.String&nbsp;infile,
                java.lang.String&nbsp;outfile)</code>
<div class="block">Reads <tt>infile</tt> and decodes it to <tt>outfile</tt>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decodeFromFile(java.lang.String)">decodeFromFile</a></strong>(java.lang.String&nbsp;filename)</code>
<div class="block">Convenience method for reading a base64-encoded
 file and decoding it.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decodeToFile(java.lang.String,%20java.lang.String)">decodeToFile</a></strong>(java.lang.String&nbsp;dataToDecode,
            java.lang.String&nbsp;filename)</code>
<div class="block">Convenience method for decoding data to a file.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.lang.Object</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decodeToObject(java.lang.String)">decodeToObject</a></strong>(java.lang.String&nbsp;encodedObject)</code>
<div class="block">Attempts to decode Base64 data and deserialize a Java
 Object within.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.lang.Object</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#decodeToObject(java.lang.String,%20int,%20java.lang.ClassLoader)">decodeToObject</a></strong>(java.lang.String&nbsp;encodedObject,
              int&nbsp;options,
              java.lang.ClassLoader&nbsp;loader)</code>
<div class="block">Attempts to decode Base64 data and deserialize a Java
 Object within.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encode(java.nio.ByteBuffer,%20java.nio.ByteBuffer)">encode</a></strong>(java.nio.ByteBuffer&nbsp;raw,
      java.nio.ByteBuffer&nbsp;encoded)</code>
<div class="block">Performs Base64 encoding on the <code>raw</code> ByteBuffer,
 writing it to the <code>encoded</code> ByteBuffer.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encode(java.nio.ByteBuffer,%20java.nio.CharBuffer)">encode</a></strong>(java.nio.ByteBuffer&nbsp;raw,
      java.nio.CharBuffer&nbsp;encoded)</code>
<div class="block">Performs Base64 encoding on the <code>raw</code> ByteBuffer,
 writing it to the <code>encoded</code> CharBuffer.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encode3to4(byte[],%20byte[],%20int,%20int)">encode3to4</a></strong>(byte[]&nbsp;b4,
          byte[]&nbsp;threeBytes,
          int&nbsp;numSigBytes,
          int&nbsp;options)</code>
<div class="block">Encodes up to the first three bytes of array <var>threeBytes</var>
 and returns a four-byte array in Base64 notation.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encode3to4(byte[],%20int,%20int,%20byte[],%20int,%20int)">encode3to4</a></strong>(byte[]&nbsp;source,
          int&nbsp;srcOffset,
          int&nbsp;numSigBytes,
          byte[]&nbsp;destination,
          int&nbsp;destOffset,
          int&nbsp;options)</code>
<div class="block">Encodes up to three bytes of the array <var>source</var>
 and writes the resulting four Base64 bytes to <var>destination</var>.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[])">encodeBytes</a></strong>(byte[]&nbsp;source)</code>
<div class="block">Encodes a byte array into Base64 notation.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[],%20int)">encodeBytes</a></strong>(byte[]&nbsp;source,
           int&nbsp;options)</code>
<div class="block">Encodes a byte array into Base64 notation.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[],%20int,%20int)">encodeBytes</a></strong>(byte[]&nbsp;source,
           int&nbsp;off,
           int&nbsp;len)</code>
<div class="block">Encodes a byte array into Base64 notation.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[],%20int,%20int,%20int)">encodeBytes</a></strong>(byte[]&nbsp;source,
           int&nbsp;off,
           int&nbsp;len,
           int&nbsp;options)</code>
<div class="block">Encodes a byte array into Base64 notation.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeBytesToBytes(byte[])">encodeBytesToBytes</a></strong>(byte[]&nbsp;source)</code>
<div class="block">Similar to <a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[])"><code>encodeBytes(byte[])</code></a> but returns
 a byte array instead of instantiating a String.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeBytesToBytes(byte[],%20int,%20int,%20int)">encodeBytesToBytes</a></strong>(byte[]&nbsp;source,
                  int&nbsp;off,
                  int&nbsp;len,
                  int&nbsp;options)</code>
<div class="block">Similar to <a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[],%20int,%20int,%20int)"><code>encodeBytes(byte[], int, int, int)</code></a> but returns
 a byte array instead of instantiating a String.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeFileToFile(java.lang.String,%20java.lang.String)">encodeFileToFile</a></strong>(java.lang.String&nbsp;infile,
                java.lang.String&nbsp;outfile)</code>
<div class="block">Reads <tt>infile</tt> and encodes it to <tt>outfile</tt>.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeFromFile(java.lang.String)">encodeFromFile</a></strong>(java.lang.String&nbsp;filename)</code>
<div class="block">Convenience method for reading a binary file
 and base64-encoding it.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeObject(java.io.Serializable)">encodeObject</a></strong>(java.io.Serializable&nbsp;serializableObject)</code>
<div class="block">Serializes an object and returns the Base64-encoded
 version of that serialized object.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeObject(java.io.Serializable,%20int)">encodeObject</a></strong>(java.io.Serializable&nbsp;serializableObject,
            int&nbsp;options)</code>
<div class="block">Serializes an object and returns the Base64-encoded
 version of that serialized object.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static void</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#encodeToFile(byte[],%20java.lang.String)">encodeToFile</a></strong>(byte[]&nbsp;dataToEncode,
            java.lang.String&nbsp;filename)</code>
<div class="block">Convenience method for encoding data to a file.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#getAlphabet(int)">getAlphabet</a></strong>(int&nbsp;options)</code>
<div class="block">Returns one of the _SOMETHING_ALPHABET byte arrays depending on
 the options specified.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private static byte[]</code></td>
<td class="colLast"><code><strong><a href="../../../org/java_websocket/util/Base64.html#getDecodabet(int)">getDecodabet</a></strong>(int&nbsp;options)</code>
<div class="block">Returns one of the _SOMETHING_DECODABET byte arrays depending on
 the options specified.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="NO_OPTIONS">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>NO_OPTIONS</h4>
<pre>public static final&nbsp;int NO_OPTIONS</pre>
<div class="block">No options specified. Value is zero.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.NO_OPTIONS">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="ENCODE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>ENCODE</h4>
<pre>public static final&nbsp;int ENCODE</pre>
<div class="block">Specify encoding in first bit. Value is one.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.ENCODE">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="DECODE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DECODE</h4>
<pre>public static final&nbsp;int DECODE</pre>
<div class="block">Specify decoding in first bit. Value is zero.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.DECODE">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="GZIP">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>GZIP</h4>
<pre>public static final&nbsp;int GZIP</pre>
<div class="block">Specify that data should be gzip-compressed in second bit. Value is two.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.GZIP">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="DONT_GUNZIP">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DONT_GUNZIP</h4>
<pre>public static final&nbsp;int DONT_GUNZIP</pre>
<div class="block">Specify that gzipped data should <em>not</em> be automatically gunzipped.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.DONT_GUNZIP">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="DO_BREAK_LINES">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>DO_BREAK_LINES</h4>
<pre>public static final&nbsp;int DO_BREAK_LINES</pre>
<div class="block">Do break lines when encoding. Value is 8.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.DO_BREAK_LINES">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="URL_SAFE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>URL_SAFE</h4>
<pre>public static final&nbsp;int URL_SAFE</pre>
<div class="block">Encode using Base64-like encoding that is URL- and Filename-safe as described
 in Section 4 of RFC3548: 
 <a href="http://www.faqs.org/rfcs/rfc3548.html">http://www.faqs.org/rfcs/rfc3548.html</a>.
 It is important to note that data encoded this way is <em>not</em> officially valid Base64, 
 or at the very least should not be called Base64 without also specifying that is
 was encoded using the URL- and Filename-safe dialect.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.URL_SAFE">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="ORDERED">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>ORDERED</h4>
<pre>public static final&nbsp;int ORDERED</pre>
<div class="block">Encode using the special "ordered" dialect of Base64 described here:
 <a href="http://www.faqs.org/qa/rfcc-1940.html">http://www.faqs.org/qa/rfcc-1940.html</a>.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.ORDERED">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="MAX_LINE_LENGTH">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>MAX_LINE_LENGTH</h4>
<pre>private static final&nbsp;int MAX_LINE_LENGTH</pre>
<div class="block">Maximum line length (76) of Base64 output.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.MAX_LINE_LENGTH">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="EQUALS_SIGN">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>EQUALS_SIGN</h4>
<pre>private static final&nbsp;byte EQUALS_SIGN</pre>
<div class="block">The equals sign (=) as a byte.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.EQUALS_SIGN">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="NEW_LINE">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>NEW_LINE</h4>
<pre>private static final&nbsp;byte NEW_LINE</pre>
<div class="block">The new line character (\n) as a byte.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.NEW_LINE">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="PREFERRED_ENCODING">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>PREFERRED_ENCODING</h4>
<pre>private static final&nbsp;java.lang.String PREFERRED_ENCODING</pre>
<div class="block">Preferred encoding.</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.PREFERRED_ENCODING">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="WHITE_SPACE_ENC">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WHITE_SPACE_ENC</h4>
<pre>private static final&nbsp;byte WHITE_SPACE_ENC</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.WHITE_SPACE_ENC">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="EQUALS_SIGN_ENC">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>EQUALS_SIGN_ENC</h4>
<pre>private static final&nbsp;byte EQUALS_SIGN_ENC</pre>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../constant-values.html#org.java_websocket.util.Base64.EQUALS_SIGN_ENC">Constant Field Values</a></dd></dl>
</li>
</ul>
<a name="_STANDARD_ALPHABET">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>_STANDARD_ALPHABET</h4>
<pre>private static final&nbsp;byte[] _STANDARD_ALPHABET</pre>
<div class="block">The 64 valid Base64 values.</div>
</li>
</ul>
<a name="_STANDARD_DECODABET">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>_STANDARD_DECODABET</h4>
<pre>private static final&nbsp;byte[] _STANDARD_DECODABET</pre>
<div class="block">Translates a Base64 value to either its 6-bit reconstruction value
 or a negative number indicating some other meaning.</div>
</li>
</ul>
<a name="_URL_SAFE_ALPHABET">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>_URL_SAFE_ALPHABET</h4>
<pre>private static final&nbsp;byte[] _URL_SAFE_ALPHABET</pre>
<div class="block">Used in the URL- and Filename-safe dialect described in Section 4 of RFC3548: 
 <a href="http://www.faqs.org/rfcs/rfc3548.html">http://www.faqs.org/rfcs/rfc3548.html</a>.
 Notice that the last two bytes become "hyphen" and "underscore" instead of "plus" and "slash."</div>
</li>
</ul>
<a name="_URL_SAFE_DECODABET">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>_URL_SAFE_DECODABET</h4>
<pre>private static final&nbsp;byte[] _URL_SAFE_DECODABET</pre>
<div class="block">Used in decoding URL- and Filename-safe dialects of Base64.</div>
</li>
</ul>
<a name="_ORDERED_ALPHABET">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>_ORDERED_ALPHABET</h4>
<pre>private static final&nbsp;byte[] _ORDERED_ALPHABET</pre>
<div class="block">I don't get the point of this technique, but someone requested it,
 and it is described here:
 <a href="http://www.faqs.org/qa/rfcc-1940.html">http://www.faqs.org/qa/rfcc-1940.html</a>.</div>
</li>
</ul>
<a name="_ORDERED_DECODABET">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>_ORDERED_DECODABET</h4>
<pre>private static final&nbsp;byte[] _ORDERED_DECODABET</pre>
<div class="block">Used in decoding the "ordered" dialect of Base64.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="Base64()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Base64</h4>
<pre>private&nbsp;Base64()</pre>
<div class="block">Defeats instantiation.</div>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getAlphabet(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getAlphabet</h4>
<pre>private static final&nbsp;byte[]&nbsp;getAlphabet(int&nbsp;options)</pre>
<div class="block">Returns one of the _SOMETHING_ALPHABET byte arrays depending on
 the options specified.
 It's possible, though silly, to specify ORDERED <b>and</b> URLSAFE
 in which case one of them will be picked, though there is
 no guarantee as to which one will be picked.</div>
</li>
</ul>
<a name="getDecodabet(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDecodabet</h4>
<pre>private static final&nbsp;byte[]&nbsp;getDecodabet(int&nbsp;options)</pre>
<div class="block">Returns one of the _SOMETHING_DECODABET byte arrays depending on
 the options specified.
 It's possible, though silly, to specify ORDERED and URL_SAFE
 in which case one of them will be picked, though there is
 no guarantee as to which one will be picked.</div>
</li>
</ul>
<a name="encode3to4(byte[], byte[], int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encode3to4</h4>
<pre>private static&nbsp;byte[]&nbsp;encode3to4(byte[]&nbsp;b4,
                byte[]&nbsp;threeBytes,
                int&nbsp;numSigBytes,
                int&nbsp;options)</pre>
<div class="block">Encodes up to the first three bytes of array <var>threeBytes</var>
 and returns a four-byte array in Base64 notation.
 The actual number of significant bytes in your array is
 given by <var>numSigBytes</var>.
 The array <var>threeBytes</var> needs only be as big as
 <var>numSigBytes</var>.
 Code can reuse a byte array by passing a four-byte array as <var>b4</var>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>b4</code> - A reusable byte array to reduce array instantiation</dd><dd><code>threeBytes</code> - the array to convert</dd><dd><code>numSigBytes</code> - the number of significant bytes in your array</dd>
<dt><span class="strong">Returns:</span></dt><dd>four byte array in Base64 notation.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.5.1</dd></dl>
</li>
</ul>
<a name="encode3to4(byte[], int, int, byte[], int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encode3to4</h4>
<pre>private static&nbsp;byte[]&nbsp;encode3to4(byte[]&nbsp;source,
                int&nbsp;srcOffset,
                int&nbsp;numSigBytes,
                byte[]&nbsp;destination,
                int&nbsp;destOffset,
                int&nbsp;options)</pre>
<div class="block"><p>Encodes up to three bytes of the array <var>source</var>
 and writes the resulting four Base64 bytes to <var>destination</var>.
 The source and destination arrays can be manipulated
 anywhere along their length by specifying 
 <var>srcOffset</var> and <var>destOffset</var>.
 This method does not check to make sure your arrays
 are large enough to accomodate <var>srcOffset</var> + 3 for
 the <var>source</var> array or <var>destOffset</var> + 4 for
 the <var>destination</var> array.
 The actual number of significant bytes in your array is
 given by <var>numSigBytes</var>.</p>
 <p>This is the lowest level of the encoding methods with
 all possible parameters.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - the array to convert</dd><dd><code>srcOffset</code> - the index where conversion begins</dd><dd><code>numSigBytes</code> - the number of significant bytes in your array</dd><dd><code>destination</code> - the array to hold the conversion</dd><dd><code>destOffset</code> - the index where output will be put</dd>
<dt><span class="strong">Returns:</span></dt><dd>the <var>destination</var> array</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="encode(java.nio.ByteBuffer, java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encode</h4>
<pre>public static&nbsp;void&nbsp;encode(java.nio.ByteBuffer&nbsp;raw,
          java.nio.ByteBuffer&nbsp;encoded)</pre>
<div class="block">Performs Base64 encoding on the <code>raw</code> ByteBuffer,
 writing it to the <code>encoded</code> ByteBuffer.
 This is an experimental feature. Currently it does not
 pass along any options (such as <a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>DO_BREAK_LINES</code></a>
 or <a href="../../../org/java_websocket/util/Base64.html#GZIP"><code>GZIP</code></a>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>raw</code> - input buffer</dd><dd><code>encoded</code> - output buffer</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3</dd></dl>
</li>
</ul>
<a name="encode(java.nio.ByteBuffer, java.nio.CharBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encode</h4>
<pre>public static&nbsp;void&nbsp;encode(java.nio.ByteBuffer&nbsp;raw,
          java.nio.CharBuffer&nbsp;encoded)</pre>
<div class="block">Performs Base64 encoding on the <code>raw</code> ByteBuffer,
 writing it to the <code>encoded</code> CharBuffer.
 This is an experimental feature. Currently it does not
 pass along any options (such as <a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>DO_BREAK_LINES</code></a>
 or <a href="../../../org/java_websocket/util/Base64.html#GZIP"><code>GZIP</code></a>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>raw</code> - input buffer</dd><dd><code>encoded</code> - output buffer</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3</dd></dl>
</li>
</ul>
<a name="encodeObject(java.io.Serializable)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeObject</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeObject(java.io.Serializable&nbsp;serializableObject)
                                     throws java.io.IOException</pre>
<div class="block">Serializes an object and returns the Base64-encoded
 version of that serialized object.  
  
 <p>As of v 2.3, if the object
 cannot be serialized or there is another error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned a null value, but
 in retrospect that's a pretty poor way to handle it.</p>
 
 The object is not GZip-compressed before being encoded.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>serializableObject</code> - The object to encode</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded object</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd>
<dd><code>java.lang.NullPointerException</code> - if serializedObject is null</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.4</dd></dl>
</li>
</ul>
<a name="encodeObject(java.io.Serializable, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeObject</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeObject(java.io.Serializable&nbsp;serializableObject,
                            int&nbsp;options)
                                     throws java.io.IOException</pre>
<div class="block">Serializes an object and returns the Base64-encoded
 version of that serialized object.
  
 <p>As of v 2.3, if the object
 cannot be serialized or there is another error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned a null value, but
 in retrospect that's a pretty poor way to handle it.</p>
 
 The object is not GZip-compressed before being encoded.
 <p>
 Example options:<pre>
   GZIP: gzip-compresses object before encoding it.
   DO_BREAK_LINES: break lines at 76 characters
 </pre>
 <p>
 Example: <code>encodeObject( myObj, Base64.GZIP )</code> or
 <p>
 Example: <code>encodeObject( myObj, Base64.GZIP | Base64.DO_BREAK_LINES )</code></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>serializableObject</code> - The object to encode</dd><dd><code>options</code> - Specified options</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded object</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.0</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/util/Base64.html#GZIP"><code>GZIP</code></a>, 
<a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>DO_BREAK_LINES</code></a></dd></dl>
</li>
</ul>
<a name="encodeBytes(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeBytes</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeBytes(byte[]&nbsp;source)</pre>
<div class="block">Encodes a byte array into Base64 notation.
 Does not GZip-compress data.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The data to convert</dd>
<dt><span class="strong">Returns:</span></dt><dd>The data in Base64-encoded form</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.NullPointerException</code> - if source array is null</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.4</dd></dl>
</li>
</ul>
<a name="encodeBytes(byte[], int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeBytes</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeBytes(byte[]&nbsp;source,
                           int&nbsp;options)
                                    throws java.io.IOException</pre>
<div class="block">Encodes a byte array into Base64 notation.
 <p>
 Example options:<pre>
   GZIP: gzip-compresses object before encoding it.
   DO_BREAK_LINES: break lines at 76 characters
     <i>Note: Technically, this makes your encoding non-compliant.</i>
 </pre>
 <p>
 Example: <code>encodeBytes( myData, Base64.GZIP )</code> or
 <p>
 Example: <code>encodeBytes( myData, Base64.GZIP | Base64.DO_BREAK_LINES )</code>

  
 <p>As of v 2.3, if there is an error with the GZIP stream,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned a null value, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The data to convert</dd><dd><code>options</code> - Specified options</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded data as a String</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd>
<dd><code>java.lang.NullPointerException</code> - if source array is null</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.0</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/util/Base64.html#GZIP"><code>GZIP</code></a>, 
<a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>DO_BREAK_LINES</code></a></dd></dl>
</li>
</ul>
<a name="encodeBytes(byte[], int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeBytes</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeBytes(byte[]&nbsp;source,
                           int&nbsp;off,
                           int&nbsp;len)</pre>
<div class="block">Encodes a byte array into Base64 notation.
 Does not GZip-compress data.
  
 <p>As of v 2.3, if there is an error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned a null value, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The data to convert</dd><dd><code>off</code> - Offset in array where conversion should begin</dd><dd><code>len</code> - Length of data to convert</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded data as a String</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.NullPointerException</code> - if source array is null</dd>
<dd><code>java.lang.IllegalArgumentException</code> - if source array, offset, or length are invalid</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.4</dd></dl>
</li>
</ul>
<a name="encodeBytes(byte[], int, int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeBytes</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeBytes(byte[]&nbsp;source,
                           int&nbsp;off,
                           int&nbsp;len,
                           int&nbsp;options)
                                    throws java.io.IOException</pre>
<div class="block">Encodes a byte array into Base64 notation.
 <p>
 Example options:<pre>
   GZIP: gzip-compresses object before encoding it.
   DO_BREAK_LINES: break lines at 76 characters
     <i>Note: Technically, this makes your encoding non-compliant.</i>
 </pre>
 <p>
 Example: <code>encodeBytes( myData, Base64.GZIP )</code> or
 <p>
 Example: <code>encodeBytes( myData, Base64.GZIP | Base64.DO_BREAK_LINES )</code>

  
 <p>As of v 2.3, if there is an error with the GZIP stream,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned a null value, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The data to convert</dd><dd><code>off</code> - Offset in array where conversion should begin</dd><dd><code>len</code> - Length of data to convert</dd><dd><code>options</code> - Specified options</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded data as a String</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd>
<dd><code>java.lang.NullPointerException</code> - if source array is null</dd>
<dd><code>java.lang.IllegalArgumentException</code> - if source array, offset, or length are invalid</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.0</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/util/Base64.html#GZIP"><code>GZIP</code></a>, 
<a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>DO_BREAK_LINES</code></a></dd></dl>
</li>
</ul>
<a name="encodeBytesToBytes(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeBytesToBytes</h4>
<pre>public static&nbsp;byte[]&nbsp;encodeBytesToBytes(byte[]&nbsp;source)</pre>
<div class="block">Similar to <a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[])"><code>encodeBytes(byte[])</code></a> but returns
 a byte array instead of instantiating a String. This is more efficient
 if you're working with I/O streams and have large data sets to encode.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The data to convert</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded data as a byte[] (of ASCII characters)</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.NullPointerException</code> - if source array is null</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3.1</dd></dl>
</li>
</ul>
<a name="encodeBytesToBytes(byte[], int, int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeBytesToBytes</h4>
<pre>public static&nbsp;byte[]&nbsp;encodeBytesToBytes(byte[]&nbsp;source,
                        int&nbsp;off,
                        int&nbsp;len,
                        int&nbsp;options)
                                 throws java.io.IOException</pre>
<div class="block">Similar to <a href="../../../org/java_websocket/util/Base64.html#encodeBytes(byte[],%20int,%20int,%20int)"><code>encodeBytes(byte[], int, int, int)</code></a> but returns
 a byte array instead of instantiating a String. This is more efficient
 if you're working with I/O streams and have large data sets to encode.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The data to convert</dd><dd><code>off</code> - Offset in array where conversion should begin</dd><dd><code>len</code> - Length of data to convert</dd><dd><code>options</code> - Specified options</dd>
<dt><span class="strong">Returns:</span></dt><dd>The Base64-encoded data as a String</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd>
<dd><code>java.lang.NullPointerException</code> - if source array is null</dd>
<dd><code>java.lang.IllegalArgumentException</code> - if source array, offset, or length are invalid</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3.1</dd>
<dt><span class="strong">See Also:</span></dt><dd><a href="../../../org/java_websocket/util/Base64.html#GZIP"><code>GZIP</code></a>, 
<a href="../../../org/java_websocket/util/Base64.html#DO_BREAK_LINES"><code>DO_BREAK_LINES</code></a></dd></dl>
</li>
</ul>
<a name="decode4to3(byte[], int, byte[], int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode4to3</h4>
<pre>private static&nbsp;int&nbsp;decode4to3(byte[]&nbsp;source,
             int&nbsp;srcOffset,
             byte[]&nbsp;destination,
             int&nbsp;destOffset,
             int&nbsp;options)</pre>
<div class="block">Decodes four bytes from array <var>source</var>
 and writes the resulting bytes (up to three of them)
 to <var>destination</var>.
 The source and destination arrays can be manipulated
 anywhere along their length by specifying 
 <var>srcOffset</var> and <var>destOffset</var>.
 This method does not check to make sure your arrays
 are large enough to accomodate <var>srcOffset</var> + 4 for
 the <var>source</var> array or <var>destOffset</var> + 3 for
 the <var>destination</var> array.
 This method returns the actual number of bytes that 
 were converted from the Base64 encoding.
 <p>This is the lowest level of the decoding methods with
 all possible parameters.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - the array to convert</dd><dd><code>srcOffset</code> - the index where conversion begins</dd><dd><code>destination</code> - the array to hold the conversion</dd><dd><code>destOffset</code> - the index where output will be put</dd><dd><code>options</code> - alphabet type is pulled from this (standard, url-safe, ordered)</dd>
<dt><span class="strong">Returns:</span></dt><dd>the number of decoded bytes converted</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.NullPointerException</code> - if source or destination arrays are null</dd>
<dd><code>java.lang.IllegalArgumentException</code> - if srcOffset or destOffset are invalid
         or there is not enough room in the array.</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="decode(byte[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre>public static&nbsp;byte[]&nbsp;decode(byte[]&nbsp;source)
                     throws java.io.IOException</pre>
<div class="block">Low-level access to decoding ASCII characters in
 the form of a byte array. <strong>Ignores GUNZIP option, if
 it's set.</strong> This is not generally a recommended method,
 although it is used internally as part of the decoding process.
 Special case: if len = 0, an empty array is returned. Still,
 if you need more speed and reduced memory footprint (and aren't
 gzipping), consider this method.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The Base64 encoded data</dd>
<dt><span class="strong">Returns:</span></dt><dd>decoded data</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3.1</dd></dl>
</li>
</ul>
<a name="decode(byte[], int, int, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre>public static&nbsp;byte[]&nbsp;decode(byte[]&nbsp;source,
            int&nbsp;off,
            int&nbsp;len,
            int&nbsp;options)
                     throws java.io.IOException</pre>
<div class="block">Low-level access to decoding ASCII characters in
 the form of a byte array. <strong>Ignores GUNZIP option, if
 it's set.</strong> This is not generally a recommended method,
 although it is used internally as part of the decoding process.
 Special case: if len = 0, an empty array is returned. Still,
 if you need more speed and reduced memory footprint (and aren't
 gzipping), consider this method.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>source</code> - The Base64 encoded data</dd><dd><code>off</code> - The offset of where to begin decoding</dd><dd><code>len</code> - The length of characters to decode</dd><dd><code>options</code> - Can specify options such as alphabet type to use</dd>
<dt><span class="strong">Returns:</span></dt><dd>decoded data</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - If bogus characters exist in source data</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.3</dd></dl>
</li>
</ul>
<a name="decode(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre>public static&nbsp;byte[]&nbsp;decode(java.lang.String&nbsp;s)
                     throws java.io.IOException</pre>
<div class="block">Decodes data from Base64 notation, automatically
 detecting gzip-compressed data and decompressing it.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>s</code> - the string to decode</dd>
<dt><span class="strong">Returns:</span></dt><dd>the decoded data</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - If there is a problem</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.4</dd></dl>
</li>
</ul>
<a name="decode(java.lang.String, int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decode</h4>
<pre>public static&nbsp;byte[]&nbsp;decode(java.lang.String&nbsp;s,
            int&nbsp;options)
                     throws java.io.IOException</pre>
<div class="block">Decodes data from Base64 notation, automatically
 detecting gzip-compressed data and decompressing it.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>s</code> - the string to decode</dd><dd><code>options</code> - encode options such as URL_SAFE</dd>
<dt><span class="strong">Returns:</span></dt><dd>the decoded data</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd>
<dd><code>java.lang.NullPointerException</code> - if <tt>s</tt> is null</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.4</dd></dl>
</li>
</ul>
<a name="decodeToObject(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeToObject</h4>
<pre>public static&nbsp;java.lang.Object&nbsp;decodeToObject(java.lang.String&nbsp;encodedObject)
                                       throws java.io.IOException,
                                              java.lang.ClassNotFoundException</pre>
<div class="block">Attempts to decode Base64 data and deserialize a Java
 Object within. Returns <tt>null</tt> if there was an error.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>encodedObject</code> - The Base64 data to decode</dd>
<dt><span class="strong">Returns:</span></dt><dd>The decoded and deserialized object</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.NullPointerException</code> - if encodedObject is null</dd>
<dd><code>java.io.IOException</code> - if there is a general error</dd>
<dd><code>java.lang.ClassNotFoundException</code> - if the decoded object is of a
         class that cannot be found by the JVM</dd><dt><span class="strong">Since:</span></dt>
  <dd>1.5</dd></dl>
</li>
</ul>
<a name="decodeToObject(java.lang.String, int, java.lang.ClassLoader)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeToObject</h4>
<pre>public static&nbsp;java.lang.Object&nbsp;decodeToObject(java.lang.String&nbsp;encodedObject,
                              int&nbsp;options,
                              java.lang.ClassLoader&nbsp;loader)
                                       throws java.io.IOException,
                                              java.lang.ClassNotFoundException</pre>
<div class="block">Attempts to decode Base64 data and deserialize a Java
 Object within. Returns <tt>null</tt> if there was an error.
 If <tt>loader</tt> is not null, it will be the class loader
 used when deserializing.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>encodedObject</code> - The Base64 data to decode</dd><dd><code>options</code> - Various parameters related to decoding</dd><dd><code>loader</code> - Optional class loader to use in deserializing classes.</dd>
<dt><span class="strong">Returns:</span></dt><dd>The decoded and deserialized object</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.lang.NullPointerException</code> - if encodedObject is null</dd>
<dd><code>java.io.IOException</code> - if there is a general error</dd>
<dd><code>java.lang.ClassNotFoundException</code> - if the decoded object is of a 
         class that cannot be found by the JVM</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.3.4</dd></dl>
</li>
</ul>
<a name="encodeToFile(byte[], java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeToFile</h4>
<pre>public static&nbsp;void&nbsp;encodeToFile(byte[]&nbsp;dataToEncode,
                java.lang.String&nbsp;filename)
                         throws java.io.IOException</pre>
<div class="block">Convenience method for encoding data to a file.

 <p>As of v 2.3, if there is a error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned false, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>dataToEncode</code> - byte array of data to encode in base64 form</dd><dd><code>filename</code> - Filename for saving encoded data</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd>
<dd><code>java.lang.NullPointerException</code> - if dataToEncode is null</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.1</dd></dl>
</li>
</ul>
<a name="decodeToFile(java.lang.String, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeToFile</h4>
<pre>public static&nbsp;void&nbsp;decodeToFile(java.lang.String&nbsp;dataToDecode,
                java.lang.String&nbsp;filename)
                         throws java.io.IOException</pre>
<div class="block">Convenience method for decoding data to a file.

 <p>As of v 2.3, if there is a error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned false, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>dataToDecode</code> - Base64-encoded data as a string</dd><dd><code>filename</code> - Filename for saving decoded data</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.1</dd></dl>
</li>
</ul>
<a name="decodeFromFile(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decodeFromFile</h4>
<pre>public static&nbsp;byte[]&nbsp;decodeFromFile(java.lang.String&nbsp;filename)
                             throws java.io.IOException</pre>
<div class="block">Convenience method for reading a base64-encoded
 file and decoding it.

 <p>As of v 2.3, if there is a error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned false, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>filename</code> - Filename for reading encoded data</dd>
<dt><span class="strong">Returns:</span></dt><dd>decoded byte array</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.1</dd></dl>
</li>
</ul>
<a name="encodeFromFile(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeFromFile</h4>
<pre>public static&nbsp;java.lang.String&nbsp;encodeFromFile(java.lang.String&nbsp;filename)
                                       throws java.io.IOException</pre>
<div class="block">Convenience method for reading a binary file
 and base64-encoding it.

 <p>As of v 2.3, if there is a error,
 the method will throw an java.io.IOException. <b>This is new to v2.3!</b>
 In earlier versions, it just returned false, but
 in retrospect that's a pretty poor way to handle it.</p></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>filename</code> - Filename for reading binary data</dd>
<dt><span class="strong">Returns:</span></dt><dd>base64-encoded string</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.1</dd></dl>
</li>
</ul>
<a name="encodeFileToFile(java.lang.String, java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>encodeFileToFile</h4>
<pre>public static&nbsp;void&nbsp;encodeFileToFile(java.lang.String&nbsp;infile,
                    java.lang.String&nbsp;outfile)
                             throws java.io.IOException</pre>
<div class="block">Reads <tt>infile</tt> and encodes it to <tt>outfile</tt>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>infile</code> - Input file</dd><dd><code>outfile</code> - Output file</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.2</dd></dl>
</li>
</ul>
<a name="decodeFileToFile(java.lang.String, java.lang.String)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>decodeFileToFile</h4>
<pre>public static&nbsp;void&nbsp;decodeFileToFile(java.lang.String&nbsp;infile,
                    java.lang.String&nbsp;outfile)
                             throws java.io.IOException</pre>
<div class="block">Reads <tt>infile</tt> and decodes it to <tt>outfile</tt>.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>infile</code> - Input file</dd><dd><code>outfile</code> - Output file</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code> - if there is an error</dd><dt><span class="strong">Since:</span></dt>
  <dd>2.2</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/Base64.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li>Prev Class</li>
<li><a href="../../../org/java_websocket/util/Base64.InputStream.html" title="class in org.java_websocket.util"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/java_websocket/util/Base64.html" target="_top">Frames</a></li>
<li><a href="Base64.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
